---
title: RTCPeerConnection.ondatachannel
slug: Web/API/RTCPeerConnection/ondatachannel
tags:
  - Event Handler
  - Experimental
  - Property
  - RTCPeerConnection
  - Reference
  - WebRTC
  - ondatachannel
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The <code><strong>RTCPeerConnection.ondatachannel</strong></code> property is an {{domxref("EventHandler")}} which specifies a function which is called when the {{event("datachannel")}} event occurs on an {{domxref("RTCPeerConnection")}}. This event, of type {{domxref("RTCDataChannelEvent")}}, is sent when an {{domxref("RTCDataChannel")}} is added to the connection by the remote peer calling {{domxref("RTCPeerConnection.createDataChannel", "createDataChannel()")}}.</p>

<p>At the time this event is received, the {{domxref("RTCDataChannel")}} it indicates may not yet actually be open. Be sure to wait for the <code>"open"</code> event to be fired on the new <code>RTCDataChannel</code> before using it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCPeerConnection</em>.ondatachannel = <em>function</em>;
</pre>

<h3 id="Value">Value</h3>

<p>Set this property to be a function you provide which receives as input a single parameter: an {{domxref("RTCDataChannelEvent")}} which provides in its <code>channel</code> property the {{domxref("RTCDataChannel")}} which has been created.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">pc.ondatachannel = function(ev) {
  console.log('Data channel is created!');
  ev.channel.onopen = function() {
    console.log('Data channel is open and ready to be used.');
  };
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-ondatachannel', 'RTCPeerConnection.ondatachannel') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.ondatachannel")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("datachannel")}} event and its type, {{domxref("RTCDataChannelEvent")}}.</li>
 <li>{{domxref("RTCPeerConnection.createDataChannel()")}}</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Simple_RTCDataChannel_sample">A simple RTCDataChannel sample</a></li>
</ul>
